#include <iostream>
#include <vector>

#define ll long long

using namespace std;

int n;

vector<vector<bool>> krugovi;

vector<int>delioci;
vector<bool> hasperiod;

ll a[200005];
ll b[200005];

bool krug(int s, int d)
{
    if(n%d)
        return false;
    int t1=(s+d)%n;
    int t2=s;
    while(t1!=s)
    {
        if(b[t1]!=b[t2])
            return false;
        t2=t1;
        t1=(t1+d)%n;
    }
    return true;
}

void update_krugovi(int p)
{
    p%=n;
    int p1=p;
    for(int i=0; i<delioci.size(); i++)
    {
        p=p1%delioci[i];
        if(delioci[i]==n)
            break;
        if(krugovi[i][p]){
            krugovi[i][p]=false;
            hasperiod[i]=false;
            continue;
        }
        krugovi[i][p]=krug(p, delioci[i]);
        if(krugovi[i][p])
        {
            bool h =true;
            for(int j=0; j<delioci[i]; j++)
            {
                if(!krugovi[i][j])
                    h=false;
            }
            hasperiod[i]=h;
        }
    }
}

void update(int p, int v)
{
    p--;
    if(v==a[p])
        return;
    a[p]=v;
    b[p]=a[p]^a[(p+1)%n];
    b[(n+p-1)%n]=a[(n+p-1)%n]^a[p];
    update_krugovi(p);
    update_krugovi(n+p-1);
}

void answer()
{
    for(int i=0; i<delioci.size(); i++)
    {
        if(hasperiod[i])
        {
            cout<<delioci[i]<<endl;
            break;
        }
    }
}

int main()
{
    cin>>n;
    for(int i=1; i<=n; i++)
        if(n%i==0)
        delioci.push_back(i);
    hasperiod=vector<bool>(delioci.size());
    for(int i=0; i<delioci.size(); i++)
    {
        hasperiod[i]=true;
        krugovi.push_back(vector<bool>(delioci[i]));
    }
    int q;
    cin>>q;
    for(int i=0; i<n; i++)
        cin>>a[i];
    for(int i=0; i<n; i++)
    {
        b[i]=a[i]^a[(i+1)%n];
    }
    for(int i=0; i<delioci.size(); i++)
    {
        int d= delioci[i];
        for(int j=0; j<d; j++)
        {
            krugovi[i][j]=krug(j, d);
            if(!krugovi[i][j])
                hasperiod[i]=false;
        }
    }
        //for(int i=0; i<n; i++)
        //    cout<<b[i]<<" ";
       // cout<<endl;
    answer();
    while(q)
    {
        int p,v;
        cin>>p>>v;
        update(p,v);
        //for(int i=0; i<n; i++)
          //  cout<<b[i]<<" ";
      //  cout<<endl;
        answer();
        q--;
    }
    return 0;
}
/**
000011

*/