#include <iostream>
#include <algorithm>

using namespace std;

const long long e = 1e9 + 7;

struct zid
{
    long long pozicija;
    long long stabilnost;
};

bool uporedi (zid prvi, zid drugi)
{
    return prvi.pozicija < drugi.pozicija;
}

int bp(zid niz[], int n)
{
    int l = 0;
    int d = n - 1;
    int s;
    while (l < d)
    {
        s = l + (d - l)/2;
        if (niz[s].pozicija > 0)
        {
            d = s - 1;
        }
        else if(niz[s].pozicija < 0)
        {
            l = s + 1;
        }
        else
            return s;
    }
    return l;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    zid zidovi[n];

    for(int i = 0; i < n; i++)
    {
        int stabilnost, pozicija;
        cin >> pozicija >> stabilnost;
        zidovi[i].pozicija = pozicija;
        zidovi[i].stabilnost = stabilnost;
    }

    sort(zidovi, zidovi + n, uporedi);

    int p = bp(zidovi, n);

    bool nema_zidova = false;
    long long vreme = 0;
    bool desno = true;
    if (zidovi[p].pozicija < 0)
        nema_zidova = true;
    else
    {
        vreme = zidovi[p].pozicija;
        zidovi[p].stabilnost -= 1;
        desno = false;
    }
    int p2 = p + 1;
    if (p2 > n-1)
    {
        p2 = p;
        p --;
    }
    cout << p << " " << p2 << endl;
    long long magacin = 0;
    while (!nema_zidova)
    {
        if (zidovi[p].stabilnost == zidovi[p2].stabilnost)
        {
            vreme = (vreme + zidovi[p].stabilnost*abs(zidovi[p].pozicija - zidovi[p2].pozicija)%e*2)%e;
            zidovi[p].stabilnost = 0;
            zidovi[p2].stabilnost = 0;
            p --;
            p2 ++;
        }
        else if (zidovi[p].stabilnost > zidovi[p2].stabilnost)
        {
            zidovi[p].stabilnost -= zidovi[p2].stabilnost;
            vreme = (vreme + zidovi[p2].stabilnost*abs(zidovi[p].pozicija - zidovi[p2].pozicija)%e*2)%e;
            zidovi[p2].stabilnost = 0;
            p2 ++;
        }
        else if (zidovi[p].stabilnost < zidovi[p2].stabilnost)
        {
            zidovi[p2].stabilnost -= zidovi[p].stabilnost;
            vreme = (vreme + zidovi[p].stabilnost*abs(zidovi[p].pozicija - zidovi[p2].pozicija)%e*2)%e;
            zidovi[p].stabilnost = 0;
            p --;
        }
        if (p2 > n-1 || (zidovi[p2].stabilnost == 0 && p2 == n-1) || p < 0 || (zidovi[p].stabilnost == 0 && p == 0))
            nema_zidova = true;
    }
    cout << vreme << endl;
    return 0;
}