#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const int N = 200010;
const int M = 2 * sqrt(N) + 10;
int n, q;
int a[N];
int b[N];
int cnt[N];
vector<int> bad(N);
vector<int> d;

int real(int i) {
    if(i <= 0) i += n;
    if(i > n) i -= n;
    return i;
}

bool isbad(int i, int d) {
    i = real(i);
    if(b[i] != b[real(i + d)]) return true;
    if(b[i] != b[real(i - d)]) return true;
    return false;
}

void rem(int i) {
    for (int j = 0; j < d.size(); j++) {
        if(d[j] == n) continue;
        if(isbad(i - d[j], d[j])) bad[j]--;
        if(isbad(i, d[j])) bad[j]--;
        if(real(i - d[j]) != real(i + d[j]) && isbad(i + d[j], d[j])) bad[j]--;
    }
}

void ins(int i) {
    //printf("ins %d\n", i);
    for (int j = 0; j < d.size(); j++) {
        //printf("wut %d\n", d[j]);
        if(d[j] == n) continue;
        //printf("??? %d\n", real(i - d[j]));
        if(isbad(i - d[j], d[j])) bad[j]++;
        if(isbad(i, d[j])) bad[j]++;
        if(real(i - d[j]) != real(i + d[j]) && isbad(i + d[j], d[j])) bad[j]++;
    }
}

void upd(int i) {
    if(i != 0 && i < n)
        rem(i), b[i] = a[i] ^ a[i + 1], ins(i);
    else
        rem(n), b[n] = a[n] ^ a[1], ins(n);
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

    scanf("%d%d", &n, &q);
    for (int i = 1; i <= n; i++) scanf("%d", &a[i]);
    for (int i = 1; i < n; i++) b[i] = a[i] ^ a[i + 1];
    b[n] = a[n] ^ a[1];

    d.clear();
    for (int i = 1; i <= n; i++)
        if (n % i == 0)
            d.push_back(i);
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j < d.size(); j++) {
            if(isbad(i, d[j])) bad[j]++;
        }
    }
    //cout << "sta" << endl;
    for (int i = 0; i < d.size(); i++) {
        if(bad[i] == 0) {
            printf("%d\n", d[i]);
            break;
        }
    }
    //printf("%d", bad[2]);
    while(q--) {
        int p, v;
        scanf("%d%d", &p, &v);
        a[p] = v;
        upd(p);
        upd(p - 1);
        for (int i = 0; i < d.size(); i++) {
            if(bad[i] == 0) {
                printf("%d\n", d[i]);
                break;
            }
        }
    }
    return 0;
}