#include <iostream>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

void Eratosten(vector<bool>& result, int n)
{
    result[0] = false;
    result[1] = false;

    for(int i = 0; i*i <= n; ++i)
    {
        if(result[i])
        {
            for(int j = i*i; j <= n; j+=i)
                result[j] = false;
        }
    }
    return;
}

void FillSet(set<int>& result, vector<bool>& primes, int n)
{
    /*
    vector<bool> prosti;
    prosti.resize(n/2+1, true);
    Eratosten(prosti, n/2);
    */

    for(int i = 2; i < n/2+1; ++i)
        if(primes[i])
        for(int j = i; j <= n; j+=i)
        result.insert(j);
}



void ModEratosten(vector<bool>& result, set<int>& outp, int n)
{
    result[0] = false;
    result[1] = false;
    for(int i = 2; i*i <= n; ++i)
    {
        if(result[i])
        {
            for(int j = i; j < n; j+=i)
            {
                if(result[j])
                {
                    result[j] = false;
                    outp.insert(j);
                }
            }

    }

}
return;
}

int bs(vector<int> arr, int n)
{
    int l = 0;
    int r = arr.size();

    while(l < r)
    {
        int s = (l+r)/2;
        if(arr[s] <= n)
            l = s+1;
        else
            r = s;
    }

    return l-1;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    vector<bool> resul;
    resul.resize(60000000, true);
    Eratosten(resul, 10000000);


    int q;
    cin >> q;
    int el;
    for(int i = 0; i < q; ++i)
    {

        cin >> el;

        set<int> res;
        FillSet(res, resul, el);

        cout << res.size() <<endl;


    }



    return 0;
}