#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <string>
#include <map>
#include <set>
using namespace std;
typedef long long ll;
vector<int> sieve(ll n)
{
/*	vector<int> sieve(n + 1, -1);
	for (int i = 2; i < sieve.size(); i+=2)
	{
		sieve[i] = 2;
	}
	for (ll i = 3; i < n; i++)
	{
		if (sieve[i] == -1)
		{
			for (ll j = i; j < sieve.size(); j+=i)
			{
				if (sieve[j] != -1)
				{
					sieve[i] = j;
					break;
				}
			}
			for (ll j = i; j < sieve.size(); j += i)
			{
				if (sieve[j] == -1)
				{
					sieve[j] = sieve[i];
				}
			}
		}
	}
	return sieve;*/
	vector<int> sieve(n + 1, -1);
	for (ll i = 2; i < n; i++)
	{
		if (sieve[i] == -1)
		{
			for (ll j = i; j < sieve.size(); j += i)
			{
				if (sieve[j] == -1)
				{
					sieve[j] = i;
				}
			}
		}
	}
	return sieve;
}
int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	int query_cnt; cin >> query_cnt;
	vector<ll> queries(query_cnt);
	for (int i = 0; i < query_cnt; i++)
		cin >> queries[i];
	sort(queries.begin(), queries.end());

	auto smallest_factor = sieve(queries.back()+1);
	vector<bool> checked(queries.back() + 1);
	checked[2] = 1;
	int l = 3;
	ll ans = 1;
	for (int i = 0; i < queries.size(); i++)
	{
		int r = queries[i];
		while (l <= r)
		{
			if (checked[smallest_factor[l]])
			{
				ans++;
				if (l%2 == 0 && !checked[l/2])
				{
					checked[l / 2] = 1;
					ans++;
				}
			}
			l++;
		}
		cout << ans << "\n";
	}

	return 0;
}